/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.chinaitop.depot.sqr.controller;


import com.chinaitop.depot.sqr.model.BizSqrEnterprise;
import com.chinaitop.depot.sqr.model.BizSqrEnterpriseApply;
import com.chinaitop.depot.sqr.model.vo.BizSqrEnterpriseApplyVO;
import com.chinaitop.depot.sqr.service.BizSqrEnterpriseService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


import javax.annotation.Resource;
import java.util.List;

/**
 * 粮食储备-承储资格企业控制器
 *
 * @author ZeroLiYi
 * @date  2024/04/28 09:56
 */

@RequestMapping(value="/sqrEnter")
@Api(tags = "粮食储备-承储资格企业控制器")
@RestController
@Validated
public class BizSqrEnterpriseController {

    @Resource
    private BizSqrEnterpriseService bizSqrEnterpriseService;


    /**
     * 下拉获取粮承储资格企业
     *
     * @author ZeroLiYi
     * @date  2024/04/28 10:01
     */
    @ApiOperation("下拉获取粮承储资格企业")
    @GetMapping("/TreeList")
    public List<BizSqrEnterprise> TreeList() {
        List<BizSqrEnterprise> list = bizSqrEnterpriseService.TreeList();
        return list;
    }

    
    @ApiOperation("粮承储资格企业详情")
    @GetMapping("/findById")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "主键", paramType = "query")
    })
    public BizSqrEnterprise findById(String id) {

        return bizSqrEnterpriseService.findById(id);
    }



    /**
     * 添加粮食储备-承储资格企业
     *
     * @author ZeroLiYi
     * @date  2024/04/28 09:56
//     */
//    @ApiOperation("添加粮食储备-承储资格企业")
//    @PostMapping("/biz/grqe/add")
//    public CommonResult<String> add(@RequestBody @Valid BizGrQeAddParam bizGrQeAddParam) {
//        bizGrQeService.add(bizGrQeAddParam);
//        return CommonResult.ok();
//    }

    /**
     * 编辑粮食储备-承储资格企业
     *
     * @author ZeroLiYi
     * @date  2024/04/28 09:56
     */
//    @ApiOperationSupport(order = 3)
//    @ApiOperation("编辑粮食储备-承储资格企业")
//    @CommonLog("编辑粮食储备-承储资格企业")
//    @SaCheckPermission("/biz/grqe/edit")
//    @PostMapping("/biz/grqe/edit")
//    public CommonResult<String> edit(@RequestBody @Valid BizGrQeEditParam bizGrQeEditParam) {
//        bizGrQeService.edit(bizGrQeEditParam);
//        return CommonResult.ok();
//    }

    /**
     * 删除粮食储备-承储资格企业
     *
     * @author ZeroLiYi
     * @date  2024/04/28 09:56
     */

//    @ApiOperation("删除粮食储备-承储资格企业")
//    @PostMapping("/biz/grqe/delete")
//    public CommonResult<String> delete(@RequestBody @Valid @NotEmpty(message = "集合不能为空")
//                                                   CommonValidList<BizGrQeIdParam> bizGrQeIdParamList) {
//        bizGrQeService.delete(bizGrQeIdParamList);
//        return CommonResult.ok();
//    }

}
