/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.chinaitop.depot.sqr.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.data.annotation.Id;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 粮食储备-承储资格企业实体
 *
 * @author ZeroLiYi
 * @date  2024/04/28 09:56
 **/
public class BizSqrEnterprise {

    /** ID */
    @Id
    @ApiModelProperty(value = "ID", position = 1)
    private String id;

    /** 创建时间 */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间", position = 2)
    private Date createTime;

    /** 创建用户 */
    @ApiModelProperty(value = "创建用户", position = 3)
    private String createUser;

    /** 修改时间 */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty(value = "修改时间", position = 4)
    private Date updateTime;

    /** 修改用户 */
    @ApiModelProperty(value = "修改用户", position = 5)
    private String updateUser;

    /** 企业；biz_unit_info的id； */
    @ApiModelProperty(value = "企业；biz_unit_info的id；", position = 6)
    private String unitInfoId;

    /** 正式职工人数 */
    @ApiModelProperty(value = "正式职工人数", position = 7)
    private Integer fullTimeStaffCount;

    /** 持证保管员数量 */
    @ApiModelProperty(value = "持证保管员数量", position = 8)
    private Integer certifiedStorekeeperCount;

    /** 持证检验员数量 */
    @ApiModelProperty(value = "持证检验员数量", position = 9)
    private Integer certifiedInspectorCount;

    /** 承储资格-有效期-截止时间 */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty(value = "承储资格-有效期-截止时间", position = 10)
    private Date storageExpireTime;

    /** 仓房设施设备情况 */
    @ApiModelProperty(value = "仓房设施设备情况", position = 11)
    private String warehouseFacilitySituation;

    /** 附件 */
    @ApiModelProperty(value = "附件", position = 12)
    private String attachment;

    /** 状态 0：保存状态；1：申请中；2：有效；3：过期； */
    @ApiModelProperty(value = "状态 0：保存状态；1：申请中；2：有效；3：过期；", position = 13)
    private Integer status;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public String getUnitInfoId() {
        return unitInfoId;
    }

    public void setUnitInfoId(String unitInfoId) {
        this.unitInfoId = unitInfoId;
    }

    public Integer getFullTimeStaffCount() {
        return fullTimeStaffCount;
    }

    public void setFullTimeStaffCount(Integer fullTimeStaffCount) {
        this.fullTimeStaffCount = fullTimeStaffCount;
    }

    public Integer getCertifiedStorekeeperCount() {
        return certifiedStorekeeperCount;
    }

    public void setCertifiedStorekeeperCount(Integer certifiedStorekeeperCount) {
        this.certifiedStorekeeperCount = certifiedStorekeeperCount;
    }

    public Integer getCertifiedInspectorCount() {
        return certifiedInspectorCount;
    }

    public void setCertifiedInspectorCount(Integer certifiedInspectorCount) {
        this.certifiedInspectorCount = certifiedInspectorCount;
    }

    public Date getStorageExpireTime() {
        return storageExpireTime;
    }

    public void setStorageExpireTime(Date storageExpireTime) {
        this.storageExpireTime = storageExpireTime;
    }

    public String getWarehouseFacilitySituation() {
        return warehouseFacilitySituation;
    }

    public void setWarehouseFacilitySituation(String warehouseFacilitySituation) {
        this.warehouseFacilitySituation = warehouseFacilitySituation;
    }

    public String getAttachment() {
        return attachment;
    }

    public void setAttachment(String attachment) {
        this.attachment = attachment;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }
}
