/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.chinaitop.depot.sqr.model;


import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.data.annotation.Id;

import java.util.Date;

/**
 * 粮食储备-承储资格企业-承储资格申请实体
 *
 * @author ZeroLiYi
 * @date  2024/04/28 10:01
 **/

public class BizSqrEnterpriseApply {

    /** 申请记录唯一标识符 */
    @Id
    @ApiModelProperty(value = "申请记录唯一标识符", position = 1)
    private Integer id;

    /** 创建人 */
    @ApiModelProperty(value = "创建人", position = 2)
    private String createUser;

    /** 创建日期 */

    @ApiModelProperty(value = "创建日期", position = 3)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createTime;

    /** 更新人 */
    @ApiModelProperty(value = "更新人", position = 4)
    private String updateUser;

    /** 更新日期 */

    @ApiModelProperty(value = "更新日期", position = 5)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date updateTime;

    /** biz_sqr_enterprise的id； */
    @ApiModelProperty(value = "biz_sqr_enterprise的id；", position = 6)
    private String sqrEnterpriseId;

    /** 企业；biz_unit_info的id； */
    @ApiModelProperty(value = "企业；biz_unit_info的id；", position = 7)
    private String unitInfoId;

    /** 申请类型 1：承储资格申请；2：承储资格延续申请；3：承储资格证书补发申请；4：信息变更申请； */
    @ApiModelProperty(value = "申请类型 1：承储资格申请；2：承储资格延续申请；3：承储资格证书补发申请；4：信息变更申请；", position = 8)
    private Integer applyType;

    /** 状态 0：保存；1：提交（申请审核）； */
    @ApiModelProperty(value = "状态 0：保存；1：提交（申请审核）；", position = 9)
    private Integer applyStatus;

    /** 承储资格年限；apply_type=2或4时，有值； */

    @ApiModelProperty(value = "承储资格年限；apply_type=2或4时，有值；", position = 10)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date storageExpireTime;

    /** 附件；apply_type=2或3或4时，有值； */
    @ApiModelProperty(value = "附件；apply_type=2或3或4时，有值；", position = 11)
    private String attachment;

    /** 补发时间；apply_type=3时，有值； */

    @ApiModelProperty(value = "补发时间；apply_type=3时，有值；", position = 12)
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date reissueTime;

    /** 正式职工人数；apply_type=4时，有值； */
    @ApiModelProperty(value = "正式职工人数；apply_type=4时，有值；", position = 13)
    private Integer fullTimeStaffCount;

    /** 持证保管员数量；apply_type=4时，有值； */
    @ApiModelProperty(value = "持证保管员数量；apply_type=4时，有值；", position = 14)
    private Integer certifiedStorekeeperCount;

    /** 持证检验员数量；apply_type=4时，有值； */
    @ApiModelProperty(value = "持证检验员数量；apply_type=4时，有值；", position = 15)
    private Integer certifiedInspectorCount;

    /** 仓房设施设备情况；apply_type=4时，有值； */
    @ApiModelProperty(value = "仓房设施设备情况；apply_type=4时，有值；", position = 16)
    private String warehouseFacilitySituation;

    /** 状态 0：保存状态；1：申请中；2：有效；3：过期； */
    @ApiModelProperty(value = "状态 0：保存状态；1：申请中；2：有效；3：过期；", position = 13)
    private Integer status;


    private String zcdz;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getSqrEnterpriseId() {
        return sqrEnterpriseId;
    }

    public void setSqrEnterpriseId(String sqrEnterpriseId) {
        this.sqrEnterpriseId = sqrEnterpriseId;
    }

    public String getUnitInfoId() {
        return unitInfoId;
    }

    public void setUnitInfoId(String unitInfoId) {
        this.unitInfoId = unitInfoId;
    }

    public Integer getApplyType() {
        return applyType;
    }

    public void setApplyType(Integer applyType) {
        this.applyType = applyType;
    }

    public Integer getApplyStatus() {
        return applyStatus;
    }

    public void setApplyStatus(Integer applyStatus) {
        this.applyStatus = applyStatus;
    }

    public Date getStorageExpireTime() {
        return storageExpireTime;
    }

    public void setStorageExpireTime(Date storageExpireTime) {
        this.storageExpireTime = storageExpireTime;
    }

    public String getAttachment() {
        return attachment;
    }

    public void setAttachment(String attachment) {
        this.attachment = attachment;
    }

    public Date getReissueTime() {
        return reissueTime;
    }

    public void setReissueTime(Date reissueTime) {
        this.reissueTime = reissueTime;
    }

    public Integer getFullTimeStaffCount() {
        return fullTimeStaffCount;
    }

    public void setFullTimeStaffCount(Integer fullTimeStaffCount) {
        this.fullTimeStaffCount = fullTimeStaffCount;
    }

    public Integer getCertifiedStorekeeperCount() {
        return certifiedStorekeeperCount;
    }

    public void setCertifiedStorekeeperCount(Integer certifiedStorekeeperCount) {
        this.certifiedStorekeeperCount = certifiedStorekeeperCount;
    }

    public Integer getCertifiedInspectorCount() {
        return certifiedInspectorCount;
    }

    public void setCertifiedInspectorCount(Integer certifiedInspectorCount) {
        this.certifiedInspectorCount = certifiedInspectorCount;
    }

    public String getWarehouseFacilitySituation() {
        return warehouseFacilitySituation;
    }

    public void setWarehouseFacilitySituation(String warehouseFacilitySituation) {
        this.warehouseFacilitySituation = warehouseFacilitySituation;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getZcdz() {
        return zcdz;
    }

    public void setZcdz(String zcdz) {
        this.zcdz = zcdz;
    }


}
