/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.chinaitop.depot.sqr.service.impl;


import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.sqr.mapper.AuditRequestMapper;
import com.chinaitop.depot.sqr.mapper.BizSqrEnterpriseApplyMapper;
import com.chinaitop.depot.sqr.mapper.BizSqrEnterpriseMapper;
import com.chinaitop.depot.sqr.model.AuditRecord;
import com.chinaitop.depot.sqr.model.AuditRequest;
import com.chinaitop.depot.sqr.model.BizSqrEnterprise;
import com.chinaitop.depot.sqr.model.BizSqrEnterpriseApply;
import com.chinaitop.depot.sqr.model.vo.BizSqrEnterpriseApplyVO;
import com.chinaitop.depot.sqr.service.AuditRecordService;
import com.chinaitop.depot.sqr.service.AuditRequestService;
import com.chinaitop.depot.sqr.service.BizSqrEnterpriseApplyService;
import com.chinaitop.depot.sqr.service.BizSqrEnterpriseService;
import com.chinaitop.depot.system.service.ButtonInfoService;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.commons.lang.ObjectUtils;
import org.springframework.stereotype.Service;
import cn.hutool.core.util.IdUtil;
import org.springframework.transaction.annotation.Transactional;


import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 粮食储备-承储资格企业-承储资格申请Service接口实现类
 *
 * @author ZeroLiYi
 * @date  2024/04/28 10:01
 **/
@Service
public class BizSqrEnterpriseApplyServiceImpl implements BizSqrEnterpriseApplyService {

    @Resource
    private BizSqrEnterpriseMapper bizSqrEnterpriseMapper;

    @Resource
    private AuditRequestMapper auditRequestMapper;


    @Resource
    private  ButtonInfoService bizGrQeApplyService;

    @Resource
    private AuditRecordService auditRecordService;
    @Resource
    private AuditRequestService auditRequestService;

    @Resource
    private  BizSqrEnterpriseApplyService bizSqrEnterpriseApplyService;

    @Resource
    private BizSqrEnterpriseService bizSqrEnterpriseService;

    @Resource
    private BizSqrEnterpriseApplyMapper bizSqrEnterpriseApplyMapper;


    @Override
    public  List<BizSqrEnterpriseApply> findByPage(String dwmc,Integer applyType,String unitInfoId){
        Map map=new HashMap<>();
        map.put("dwmc",dwmc);
        map.put("applyType",applyType);
        map.put("unitInfoId",unitInfoId);
       return bizSqrEnterpriseApplyMapper.findByPage(map);
    }

    @Override
    public BizSqrEnterpriseApplyVO findById(Integer applyType,String unitInfoId,Integer id){
        Map map =new HashMap<>();
        if(applyType==1){
            map.put("id",id);
            map.put("applyType",applyType);
            map.put("unitInfoId",unitInfoId);
            return bizSqrEnterpriseApplyMapper.findById(map);
        }else if(applyType==4){
            map.put("id",id);
            map.put("applyType",applyType);
            map.put("unitInfoId",unitInfoId);
            return bizSqrEnterpriseApplyMapper.findById4(map);
        }else{
            map.put("id",id);
            map.put("applyType",applyType);
            map.put("unitInfoId",unitInfoId);
            return bizSqrEnterpriseApplyMapper.findById1(map);
        }

    }

    @Override
    @Transactional
    public Map<String, Object> saveOrUpdate(BizSqrEnterpriseApply bizSqrEnterpriseApply) throws Exception {
        Map<String, Object> modelMap = new HashMap<String, Object>();
        JSONObject user = null;
        JSONObject org = null;
        Integer orgId = null;
        String userName = "";
        Map<String, Object> modelMap1 = new HashMap<String, Object>();
        String msg= "该企业已有承储资格，请勿重复申请";
        //获取单位信息
        String dwbm = "";
        String ajbm ="";

        Date date = new Date();
        // JSON字符串转对象
        ObjectMapper mapper = new ObjectMapper();

        String unitInfoId =bizSqrEnterpriseApply.getUnitInfoId();
        BizSqrEnterprise bizSqrEnterprise=bizSqrEnterpriseMapper.fibdByEnterprise(unitInfoId);

       // BizSqrEnterpriseApply bSqrEnterpriseApply = bizSqrEnterpriseApplyService.findById(bizSqrEnterpriseApplyId);
        if(bizSqrEnterpriseApply.getApplyStatus()==0){
            if(bizSqrEnterpriseApply.getApplyType()==4){
                if(bizSqrEnterpriseApply.getId()!=null){
                    bizSqrEnterpriseApplyMapper.delete(bizSqrEnterpriseApply.getId());
                    bizSqrEnterpriseApply.setCreateTime(new Date());
                    bizSqrEnterpriseApply.setUpdateTime(new Date());
                    bizSqrEnterpriseApplyMapper.insert(bizSqrEnterpriseApply);
                }else{

                    bizSqrEnterpriseApply.setCreateTime(new Date());
                    bizSqrEnterpriseApply.setUpdateTime(new Date());
                    bizSqrEnterpriseApplyMapper.insert(bizSqrEnterpriseApply);
                }

            }else{
                if(bizSqrEnterpriseApply.getId()!=null){
                    bizSqrEnterpriseService.delete(bizSqrEnterpriseApply.getSqrEnterpriseId());
                    bizSqrEnterpriseApplyMapper.delete(bizSqrEnterpriseApply.getId());

                    saveAndcreatEbizSqrEnterprise(bizSqrEnterpriseApply,userName);
                }else{
                    if(bizSqrEnterpriseApply.getApplyType()==1){
                        if(bizSqrEnterprise!=null){
                            modelMap.put("error", msg);
                            return modelMap;
                        }
                    }
                        saveAndcreatEbizSqrEnterprise(bizSqrEnterpriseApply,userName);


                }
            }

        }else { //提交
            //if(bizSqrEnterpriseApplyId!=0){
                if(bizSqrEnterpriseApply.getId()!=null){

                    if(bizSqrEnterpriseApply.getApplyType()!=4){
                        auditRequestMapper.delete(bizSqrEnterpriseApply.getId()+"");
                        if(bizSqrEnterpriseApply.getApplyType()==1){
                            bizSqrEnterpriseService.delete(bizSqrEnterpriseApply.getSqrEnterpriseId());
                        }
                        bizSqrEnterpriseApplyMapper.delete(bizSqrEnterpriseApply.getId());
                        saveAndcreatEbizSqrEnterprise(bizSqrEnterpriseApply,userName);
                        saveAndcreatRequest(bizSqrEnterpriseApply,userName);
                    }else{
                        auditRequestMapper.delete(bizSqrEnterpriseApply.getId()+"");
                        bizSqrEnterpriseApplyMapper.delete(bizSqrEnterpriseApply.getId());
                        bizSqrEnterpriseApply.setCreateTime(new Date());
                        bizSqrEnterpriseApply.setUpdateTime(new Date());
                        bizSqrEnterpriseApplyMapper.insert(bizSqrEnterpriseApply);
                        saveAndcreatRequest(bizSqrEnterpriseApply,userName);
                    }

                }else{
                    if(bizSqrEnterpriseApply.getApplyType()!=4){
                        if(bizSqrEnterpriseApply.getApplyType()==1){
                            if(bizSqrEnterprise!=null){
                                modelMap.put("error", msg);
                                return modelMap;
                            }
                        }
                        saveAndcreatEbizSqrEnterprise(bizSqrEnterpriseApply,userName);
                        saveAndcreatRequest(bizSqrEnterpriseApply,userName);
                    }else{
                        bizSqrEnterpriseApplyMapper.delete(bizSqrEnterpriseApply.getId());
                        bizSqrEnterpriseApply.setCreateTime(new Date());
                        bizSqrEnterpriseApply.setUpdateTime(new Date());

                        saveAndcreatEbizSqrEnterprise(bizSqrEnterpriseApply,userName);
                        saveAndcreatRequest(bizSqrEnterpriseApply,userName);
                    }
                }

        }
        modelMap.put("status", "success");
        return modelMap;
    }

    @Override
    public void
    remove(Integer applyType,String unitInfoId,Integer enterpriseApplyId) {
        //查找
        BizSqrEnterpriseApplyVO bizSqrEnterpriseApplyVO = bizSqrEnterpriseApplyService.findById(applyType,unitInfoId,enterpriseApplyId);
        bizSqrEnterpriseService.delete(bizSqrEnterpriseApplyVO.getSqrEnterpriseId());//删除资格企业
        bizSqrEnterpriseApplyMapper.delete(enterpriseApplyId);//删除申请
    }

    private int saveAndcreatEbizSqrEnterprise(BizSqrEnterpriseApply bizSqrEnterpriseApply,String userName){
        BizSqrEnterprise bizSqrEnterprise = new BizSqrEnterprise();
        if(bizSqrEnterpriseApply.getApplyType()==1) {
            long snowflakeId = IdUtil.getSnowflake().nextId();
            bizSqrEnterprise.setId(String.valueOf(snowflakeId));
            bizSqrEnterprise.setUnitInfoId(bizSqrEnterpriseApply.getUnitInfoId());
            bizSqrEnterprise.setFullTimeStaffCount(bizSqrEnterpriseApply.getFullTimeStaffCount());
            bizSqrEnterprise.setCertifiedStorekeeperCount(bizSqrEnterpriseApply.getCertifiedStorekeeperCount());
            bizSqrEnterprise.setCertifiedInspectorCount(bizSqrEnterpriseApply.getCertifiedInspectorCount());
            bizSqrEnterprise.setStorageExpireTime(bizSqrEnterpriseApply.getStorageExpireTime());
            bizSqrEnterprise.setWarehouseFacilitySituation(bizSqrEnterpriseApply.getWarehouseFacilitySituation());
            bizSqrEnterprise.setAttachment(bizSqrEnterpriseApply.getAttachment());
            bizSqrEnterprise.setStatus(bizSqrEnterpriseApply.getApplyStatus());
            bizSqrEnterprise.setCreateTime(new Date());
            bizSqrEnterprise.setUpdateTime(new Date());

            bizSqrEnterpriseService.add(bizSqrEnterprise);
            bizSqrEnterpriseApply.setSqrEnterpriseId(bizSqrEnterprise.getId());
            bizSqrEnterpriseApply.setCreateTime(new Date());
            bizSqrEnterpriseApply.setUpdateTime(new Date());
            return bizSqrEnterpriseApplyMapper.insert(bizSqrEnterpriseApply);
        }

        bizSqrEnterpriseApply.setCreateTime(new Date());
        bizSqrEnterpriseApply.setUpdateTime(new Date());
        return bizSqrEnterpriseApplyMapper.insert(bizSqrEnterpriseApply);

    }

    private void saveAndcreatRequest(BizSqrEnterpriseApply bizSqrEnterpriseApply,String userName){
        long snowflakeId = IdUtil.getSnowflake().nextId();

        AuditRequest auditRequest =new AuditRequest();
        AuditRecord  auditRecord =new AuditRecord();
        auditRequest.setId(String.valueOf(snowflakeId));
        if(bizSqrEnterpriseApply.getApplyType()==1){

        }
        auditRequest.setType(3);
        auditRequest.setStep(1);
        auditRequest.setRequestId(bizSqrEnterpriseApply.getId()+"");
        auditRequest.setAuditStatus(0);
        auditRequest.setAttachment(bizSqrEnterpriseApply.getAttachment());
        auditRequest.setCreateTime(new Date());
        auditRequest.setUpdateTime(new Date());
      int auditRequestId = auditRequestService.insert(auditRequest);
        long auditRecordId = IdUtil.getSnowflake().nextId();
        auditRecord.setId(auditRecordId);
        auditRecord.setAuditRequestId(auditRequest.getId());
        auditRecord.setType(3);
        auditRecord.setStep(1);
        auditRecord.setRequestId(bizSqrEnterpriseApply.getId()+"");
        auditRecord.setAuditStatus(0);
        auditRecord.setAttachment(bizSqrEnterpriseApply.getAttachment());
        auditRecord.setCreateTime(new Date());
        auditRecord.setUpdateTime(new Date());
        auditRecordService.insert(auditRecord);
    }

	@Override
	public void deleteById(Integer enterpriseApplyId) {
		// TODO Auto-generated method stub
		bizSqrEnterpriseApplyMapper.delete(enterpriseApplyId);
	}
}
